----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:19:12 02/12/2016 
-- Design Name: 
-- Module Name:    tmp - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

---- Uncomment the following library declaration if using
---- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;
----use IEEE.std_logic_unsigned.all;
----use IEEE.std_logic_arith.all;
--
---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--Library UNISIM;
--use UNISIM.vcomponents.all;

entity tmp is
	 Generic (CLKIN_PERIOD : real := 10.0);
    Port ( enable : in std_logic;
			  clk : in std_logic; 
			  rst : in std_logic; 
			  out1 : out std_logic;
           out2 : out std_logic;
			  out3 : out std_logic;
			  out4 : out std_logic
			 );
end tmp;

architecture Behavioral of tmp is


	signal selectController : integer range 1 to 3;
	signal writeAllRegToDriver : std_logic; 
	signal writeOneRegToDriver : std_logic; 
	signal regAddress : std_logic_vector(2 downto 0); 
	signal dataToIntReg : std_logic_vector(11 downto 0); 

	constant dataLength : integer := 16;
	constant T_clk : integer := 20; 	-- 10 ns



	component SPI_writeReg 
	 Generic ( dataLength : integer;   
				  T_clk : integer);		
    Port (  clk : in  STD_LOGIC;		
				enable : in STD_LOGIC; 	
				rst : in STD_LOGIC;	
				selectController : in integer range 1 to 3;
				writeAllRegToDriver : in std_logic; 
				writeOneRegToDriver : in std_logic; 
				regAddress : in  std_logic_vector(2 downto 0);
				dataToIntReg : in std_logic_vector(11 downto 0);
				SCS : out  STD_LOGIC; 
				SCLK : out  STD_LOGIC;
				DATAtoDRIVER : out  STD_LOGIC;
				writeDone : out std_logic
			); 
	end component; 
	
begin



	SPI_writeReg_inst : SPI_writeReg 
	 generic map ( dataLength => dataLength,
						T_clk => T_clk)	
    port map ( clk => clk,		
					enable => enable, 	
					rst => rst,	
					selectController => selectController,
					writeAllRegToDriver => writeAllRegToDriver,
					writeOneRegToDriver => writeOneRegToDriver,
					regAddress => regAddress,
					dataToIntReg => dataToIntReg,
					SCS => out1,
					SCLK => out2,
					DATAtoDRIVER => out3,
					writeDone => out4
					); 
					

--process
--begin
--wait until rising_edge(clk);
	dataToIntReg <= "000000000000";
	regAddress <= "000";
	writeAllRegToDriver <= '1';
	writeOneRegToDriver <= '0';
	selectController <= 1;
--end process; 
	
end Behavioral;

